open Attr;;

(* annotate.ml
 *)

let rec count_tags table = 
  let rec count_tags2 table = 
    match table with 
      []            -> (default, [])
    | ((s, ctx)::t) -> 
	let (octx, rest) = count_tags2 t in
	let count_bool_feature mine other = 
	  let (off, ofn) = other in
	  let (mf, _) = mine in
	    if (mf = off) then (mf, ofn + 1)
	    else (mf, 1)
	in

	(* bold section *)
	let (myb, newbn) = count_bool_feature ctx.b octx.b in
	let (myem, newemn) = count_bool_feature ctx.em octx.em in
	let (myi, newin) = count_bool_feature ctx.i octx.i in
	let (mypl, newpln) = count_bool_feature ctx.pl octx.pl in
	let (mys, newsn) = count_bool_feature ctx.s octx.s in
	let (mytt, newttn) = count_bool_feature ctx.tt octx.tt in
	let (myu1, newu1n) = count_bool_feature ctx.u1 octx.u1 in
	let (myu2, newu2n) = count_bool_feature ctx.u2 octx.u2 in
	let (myu3, newu3n) = count_bool_feature ctx.u3 octx.u3 in
	let (myz0, newzn0) = count_bool_feature ctx.z0 octx.z0 in
	let (myz1, newzn1) = count_bool_feature ctx.z1 octx.z1 in
	let (myz2, newzn2) = count_bool_feature ctx.z2 octx.z2 in
	let (myz3, newzn3) = count_bool_feature ctx.z3 octx.z3 in
	let (myz4, newzn4) = count_bool_feature ctx.z4 octx.z4 in
	let (myz5, newzn5) = count_bool_feature ctx.z5 octx.z5 in
	let (myz6, newzn6) = count_bool_feature ctx.z6 octx.z6 in
	let (myz7, newzn7) = count_bool_feature ctx.z7 octx.z7 in
	let (myz8, newzn8) = count_bool_feature ctx.z8 octx.z8 in
	let (myz9, newzn9) = count_bool_feature ctx.z9 octx.z9 in
	let (myclr, newclrn) = count_bool_feature ctx.clr octx.clr in
	let (myclg, newclgn) = count_bool_feature ctx.clg octx.clg in
	let (myclb, newclbn) = count_bool_feature ctx.clb octx.clb in
	let (myclc, newclcn) = count_bool_feature ctx.clc octx.clc in
	let (mycly, newclyn) = count_bool_feature ctx.cly octx.cly in
	let (myclm, newclmn) = count_bool_feature ctx.clm octx.clm in
	let (myclk, newclkn) = count_bool_feature ctx.clk octx.clk in
	let (myclw, newclwn) = count_bool_feature ctx.clw octx.clw in

	let newctx = 
	  { ctx with b = (myb, newbn); em = (myem, newemn); 
	      i = (myi, newin); pl = (mypl, newpln); 
	      s = (mys, newsn); tt = (mytt, newttn); 
	      u1 = (myu1, newu1n);
	    u2 = (myu2, newu2n); u3 = (myu3, newu3n); 
	    z0 = (myz0, newzn0); clr = (myclr, newclrn);
	    z1 = (myz1, newzn1); clg = (myclg, newclgn);
	    z2 = (myz2, newzn2); clb = (myclb, newclbn);
	    z3 = (myz3, newzn3); clc = (myclc, newclcn);
	    z4 = (myz4, newzn4); cly = (mycly, newclyn);
	    z5 = (myz5, newzn5); clm = (myclm, newclmn);
	    z6 = (myz6, newzn6); clk = (myclk, newclkn);
	    z7 = (myz7, newzn7); clw = (myclw, newclwn);
	    z8 = (myz8, newzn8); z9 = (myz9, newzn9)
	  } 
	in (newctx,(s, newctx)::rest)
  in
  let (_, new_table) = count_tags2 table in
  new_table
;;    
