{ 
  open Tokens
}

              (* TAB    LF     CR     SP*)
let space = ['\009' '\010' '\015' '\032']

                 (* !  -   ;      =      ?  -   *)
let printable = ['\033' - '\059''\061''\063'-'\126']
    
    rule tok = parse
| "<B>"                { BO }        
| "<EM>"               { EM }
| "<I>"                { I }
| "<PL>"               { PL }
| "<S>"                { S }      
| "<TT>"               { TT }
| "<U>"                { UL }
| "<0>"                { Z0 }        
| "<1>"                { Z1 }         
| "<2>"                { Z2 }         
| "<3>"                { Z3 }       
| "<4>"                { Z4 }        
| "<5>"                { Z5 }        
| "<6>"                { Z6 }         
| "<7>"                { Z7 }       
| "<8>"                { Z8 }       
| "<9>"                { Z9 }        
| "<r>"                { CLR }         
| "<g>"                { CLG }       
| "<b>"                { CLB }        
| "<c>"                { CLC }
| "<m>"                { CLM }     
| "<y>"                { CLY }      
| "<k>"                { CLK }       
| "<w>"                { CLW }       

| "</B>"                { E_BO }        
| "</EM>"               { E_EM }
| "</I>"                { E_I }
| "</PL>"               { E_PL }
| "</S>"                { E_S }      
| "</TT>"               { E_TT }
| "</U>"                { E_UL }
| "</0>"                { E_Z0 }        
| "</1>"                { E_Z1 }         
| "</2>"                { E_Z2 }         
| "</3>"                { E_Z3 }       
| "</4>"                { E_Z4 }        
| "</5>"                { E_Z5 }        
| "</6>"                { E_Z6 }         
| "</7>"                { E_Z7 }       
| "</8>"                { E_Z8 }       
| "</9>"                { E_Z9 }        
| "</r>"                { E_CLR }         
| "</g>"                { E_CLG }       
| "</b>"                { E_CLB }        
| "</c>"                { E_CLC }
| "</m>"                { E_CLM }     
| "</y>"                { E_CLY }      
| "</k>"                { E_CLK }       
| "</w>"                { E_CLW }       

| printable+             { Text(Lexing.lexeme lexbuf) }
| space+                 { Space(Lexing.lexeme lexbuf) }
| eof                    { EOF }
{ (* trailer *) }
