(************************************************************************)
(*                              *                                       *)
(*        db         db         *                                       *)
(*      d88           88        *                                       *)
(*     888            888       *                                       *)
(*    d88             888b      *  ICFP 2001 Programming Contest        *)
(*    888             d88P      *  Team Lambda-Cow Entry                *)
(*    Y888b  /``````\8888       *                                       *)
(*  ,----Y888        Y88P`````\ *  Nate Foster <01jnf@cs.williams.edu>  *)
(*  |        ,'`\_/``\ |,,    | *  Shimon Rura <03sr@cs.williams.edu>   *)
(*   \,,,,-| | o | o / |  ````  *                                       *)
(*         |  """ """  |        *  main.ml                              *)
(*        /             \       *                                       *)
(*       |               \      *                                       *)
(*       |  ,,,,----'''```|     *                                       *)
(*       |``   @    @     |     *                                       *)
(*        \,,    ___    ,,/     *                                       *)
(*           \__|___|__/        *                                       *)
(*                              *                                       *)
(************************************************************************)

open Attr;;
open Best;;

exception Timeup;;

let main () =
  begin try
    let timeout1 = int_of_string Sys.argv.(1) in
    let timeout = int_of_float(0.96 *. float_of_int(timeout1)) in
    let _ = Sys.set_signal Sys.sigalrm
	      (Sys.Signal_handle (fun _ -> raise Timeup));
      Unix.alarm timeout 
    in
    let input = Lex2.grab (Lexing.from_channel stdin) in
    let best = Best.init input in
    let lexbuf = Lexing.from_string input in
    let result = Parser.main lexbuf in 
    let table2 = Annotate.count_tags result in
    let table3 = Range.overlap_resolution table2 in
    let table4 = Annotate.count_tags table3 in
    let s2 = Render.render table4 in
      Best.update s2;
      print_string(Best.best ());
      flush stdout;
      exit 0
  with _ -> 
    print_string (Best.best ());
    flush stdout;
    exit 0
  end  
    
let _ = main ()
