open Tokens;;
open Attr;;
exception SyntaxError of string;;

let main lexbuf = 	
  let rec doc lexbuf ctx end_tok = 
    let tok = Lexer.tok lexbuf in
(*    print_string ("called parse doc with end_tok: " 
		  ^ tok2string end_tok ^ " and tok: " 
		  ^ tok2string tok ^ "\n"); flush stdout;
*)
    let d1 = 
      if (tok = end_tok) then []
      else
	let newctx = tok2ctx tok ctx in
	
	(* parse/simplify white space *)
	let space str ctx = 
	  let elim_dbl_white s = 
	    let dbl_white = Str.regexp "['\009' '\010' '\015' '\032']+" in
	      Str.global_replace dbl_white " " s
	  in
	  let (u1,_) = ctx.u1 in
	  let (tt,_) = ctx.tt in
	  let newstr = 
	    if (tt = True) then str
	    else elim_dbl_white str
	  in
	    (newstr, space_ctx ctx (u1 = True))::[]
	in
	  match tok with
	    | Text t   -> (t, ctx)::[]
	    | Space s  -> space s ctx
	    | BO       -> doc lexbuf newctx E_BO  
	    | EM       -> doc lexbuf newctx E_EM  
	    | I        -> doc lexbuf newctx E_I   
	    | PL       -> doc lexbuf newctx E_PL  
	    | S        -> doc lexbuf newctx E_S   
	    | TT       -> doc lexbuf newctx E_TT  
	    | UL       -> doc lexbuf newctx E_UL  
	    | Z0       -> doc lexbuf newctx E_Z0  
	    | Z1       -> doc lexbuf newctx E_Z1  
	    | Z2       -> doc lexbuf newctx E_Z2  
	    | Z3       -> doc lexbuf newctx E_Z3  
	    | Z4       -> doc lexbuf newctx E_Z4  
	    | Z5       -> doc lexbuf newctx E_Z5  
	    | Z6       -> doc lexbuf newctx E_Z6  
	    | Z7       -> doc lexbuf newctx E_Z7  
	    | Z8       -> doc lexbuf newctx E_Z8  
	    | Z9       -> doc lexbuf newctx E_Z9  
	    | CLR      -> doc lexbuf newctx E_CLR 
	    | CLG      -> doc lexbuf newctx E_CLG 
	    | CLB      -> doc lexbuf newctx E_CLB 
	    | CLC      -> doc lexbuf newctx E_CLC 
	    | CLY      -> doc lexbuf newctx E_CLY 
	    | CLM      -> doc lexbuf newctx E_CLM 
	    | CLK      -> doc lexbuf newctx E_CLK 
	    | CLW      -> doc lexbuf newctx E_CLW 
	    | err_tok  -> 
		raise (SyntaxError ("expected: " 
				^ tok2string end_tok ^ ", got: " 
				^ tok2string err_tok))
    in
      if (d1 = [] && tok == end_tok) then d1 
      else d1 @ doc lexbuf ctx end_tok
  in
    doc lexbuf default EOF
      




