open Attr;;

let print_tab () = print_string "\t";;

let rec print_strings doc = 
  match doc with 
      [] -> print_newline()
    | (t,_)::l -> print_string ("[" ^ t ^ "]"); print_tab (); print_strings l

and  print_b doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.b; print_tab (); print_b l

and  print_em doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.em; print_tab (); print_em l;

and  print_i doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.i; print_tab (); print_i l;

and  print_pl doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.pl; print_tab (); print_pl l;

and  print_s doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.s; print_tab (); print_s l;

and  print_tt doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.tt; print_tab (); print_tt l;

and  print_u1 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.u1; print_tab (); print_u1 l;

and  print_u2 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.u2; print_tab (); print_u2 l;

and  print_u3 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.u3; print_tab (); print_u3 l;

and  print_z0 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z0; print_tab (); print_z0 l;

and  print_z1 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z1; print_tab (); print_z1 l;

and  print_z2 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z2; print_tab (); print_z2 l;

and  print_z3 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z3; print_tab (); print_z3 l;

and  print_z4 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z4; print_tab (); print_z4 l;

and  print_z5 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z5; print_tab (); print_z5 l;

and  print_z6 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z6; print_tab (); print_z6 l;

and  print_z7 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z7; print_tab (); print_z7 l;

and  print_z8 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z8; print_tab (); print_z8 l;

and  print_z9 doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.z9; print_tab (); print_z9 l;

and  print_clr doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clr; print_tab (); print_clr l;

and  print_clg doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clg; print_tab (); print_clg l;

and  print_clb doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clb; print_tab (); print_clb l;

and  print_clc doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clc; print_tab (); print_clc l;

and  print_cly doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.cly; print_tab (); print_cly l;

and  print_clm doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clm; print_tab (); print_clm l;

and  print_clk doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clk; print_tab (); print_clk l;

and  print_clw doc =
  match doc with
      [] -> print_newline()
    | (_,ctx)::l -> print_triplean ctx.clw; print_tab (); print_clw l;

and print_triplean (v,n) = 
  match v with 
      True -> print_string  "  [X:"; print_int n; print_string "]  "
    | False -> print_string "  [_:"; print_int n; print_string "]  "
    | Star -> print_string  "  [*:"; print_int n; print_string "]  "
    | Any -> print_string  "  [?:"; print_int n; print_string "]  "

and print_table doc =	     
  print_string "*:\t";    print_strings doc;
  print_string "b:\t";    print_b doc;
  print_string "em:\t";   print_em doc;
  print_string "i:\t";    print_i doc;
  print_string "pl:\t";   print_pl doc;
  print_string "s:\t";     print_s doc;
  print_string "tt:\t";    print_tt doc;
  print_string "u1:\t";   print_u1 doc;
  print_string "u2:\t";   print_u2 doc;
  print_string "u3:\t";   print_u3 doc;
  print_string "z0:\t";    print_z0 doc;
  print_string "z1:\t";    print_z1 doc;
  print_string "z2:\t";    print_z2 doc;
  print_string "z3:\t";    print_z3 doc;
  print_string "z4:\t";    print_z4 doc;
  print_string "z5:\t";    print_z5 doc;
  print_string "z6:\t";    print_z6 doc;
  print_string "z7:\t";    print_z7 doc;
  print_string "z8:\t";    print_z8 doc;
  print_string "z9:\t";    print_z9 doc;
  print_string "clr:\t";   print_clr doc;
  print_string "clg:\t";   print_clg doc;
  print_string "clb:\t";   print_clb doc;
  print_string "clc:\t";   print_clc doc;
  print_string "cly:\t";   print_cly doc;
  print_string "clm:\t";   print_clm doc;
  print_string "clk:\t";   print_clk doc;
  print_string "clw:\t";   print_clw doc
